#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include <ctype.h>


double TOKVAL;

char *buf = 0;
int len = 0;
int i;
int quit_val = 0;

int next (void)
{
	int c;

	/* Игнорировать промежутки, получить первый непробельный символ.  */
	while ((c = getchar ()) == ' ' || c == '\t');

	if (c == EOF)
		return 0;
	
	/* Разбор операторов -----------------------------*/	
	if (strchr("=+-*/^()<>!%,{}[]", c) != NULL) {

		if (len == 0) len = 2;
		buf = (char *)malloc (len + 1);

		i = 0;
		/*do
		{
			buf[i++] = c;
			c = getchar ();
			
		}
		while (c != EOF && strchr("=+-/*^()|&%", c) != NULL && i < 2);*/
		
		switch (c) {
			case ',':
			case '[':
			case ']':
			case '{':
			case '}':
			case '(':
			case ')':
				buf[i++] = c;
				c = getchar();
				ungetc (c, stdin);
				break;
			case '+':
				buf[i++] = c;
				c = getchar(); 
				if (strchr("+=", c) != NULL) {
					buf[i++] = c;
					break;	
				}
				ungetc (c, stdin);
				break;
			case '-':
				buf[i++] = c;
				c = getchar(); 
				if (strchr("-=", c) != NULL) {
					buf[i++] = c;
					break;	
				}
				ungetc (c, stdin);
				break;
			case '*':
			case '/':
			case '%':
			case '^':
			case '!':
			case '>':
			case '<':
			case '=':
				buf[i++] = c;
				c = getchar(); 
				if (c == '=') {
					buf[i++] = c;
					break;	
				}
				ungetc (c, stdin);
				break;
			
				
			default:
				break;
		}

		buf[i] = '\0';
		
		printf("%s\n", buf);
		
		return;
	}

	/* Разбор чисел----------------------------------- */
	if (c == '.' || isdigit (c))
	{
		ungetc (c, stdin);
		scanf ("%lf", &TOKVAL);
		
		printf("%.9g\n", TOKVAL);
		
		return;
	}

	/* Разбор имен функций или констант ----------------------------*/
	if (isalpha (c) || c == '_')
	{
		if (len == 0) len = 10;
		
		buf = (char *)malloc (len + 1);

		i = 0;
		do
		{
			if (i == len)
			{
				len *= 2;
				buf = (char *)realloc (buf, len + 1);
			}
			
			buf[i++] = c;
			
			c = getchar ();
		}
		while ((c != EOF && isalnum (c)) || (c != EOF && c == '_'));

		ungetc (c, stdin);
		
		buf[i] = '\0';
		
		if (buf[0] == 'q' && buf[1] == 'u' && buf[2] == 'i' &&
		    buf[3] == 't' && buf[4] == NULL && buf[4] == NULL) 
			quit_val = 1;
		
		if (quit_val == 0) printf("%s\n", buf);

		return;
	}

	return;
}


int main(int argc, char *argv[])
{
	
	while (1) {
		next();
 		if (quit_val == 1) break;
	}
	
	free(buf);

  return EXIT_SUCCESS;
}
